
# Player death

execute as @a[scores={killed=1..}] at @s run function main:tools/death
function main:game/player_death/loop

execute as @a[team=!Spectator] at @s unless block ~ ~-1 ~ air run effect clear @s minecraft:slow_falling

# Glowing to the firstplayer / team

execute as @a[scores={rankSingle=1}] run tag @s add firstRanked
execute as @a[scores={rankSingle=2..},tag=connected] run tag @s remove firstRanked
execute unless score event_id itemsTimer matches 9 as @a[scores={rankSingle=1}] run effect give @s minecraft:glowing 1 0 true
execute if entity @e[tag=!enableTeams,tag=x] as @a[scores={rankSingle=2..}] run effect clear @s minecraft:glowing

# Bossbar
execute if entity @e[tag=x,tag=!generating,scores={sGameType=2}] run function main:game/bossbar/time/loop
execute if entity @e[tag=x,tag=!generating,scores={sGameType=1}] run function main:game/bossbar/score/loop

# if a player get in the water he get a bad effect in the map 2

tag @a remove withered
execute as @e[tag=x,type=armor_stand,scores={sMap=2}] run execute as @a[team=!Spectator] at @s if block ~ ~ ~ water run tag @s add withered
effect give @a[tag=withered] minecraft:wither 1 10 true
title @a[tag=withered] actionbar [{"text":"» "},{"text":"Beware, the water is too deep for you!","color":"dark_green"},{"text":" «"}]

# Anti-fall system on the map 1 but loose 5 points

execute as @a[team=!Spectator,x=5050,y=75,z=-5050,dx=-100,dy=-75,dz=100,tag=!fallingVoid] at @s run function main:tools/loose_5_points
execute as @a[team=!Spectator,x=5050,y=75,z=-5050,dx=-100,dy=-75,dz=100,tag=!fallingVoid] at @s run tellraw @s ["",{"text":"\u25b6 "},{"text":"Don't go that far! You're loosing points!","color":"dark_red"}]
tag @a[team=!Spectator,x=5050,y=75,z=-5050,dx=-100,dy=-75,dz=100] add fallingVoid
effect give @a[team=!Spectator,x=5050,y=75,z=-5050,dx=-100,dy=-75,dz=100] minecraft:levitation 1 20 true
advancement grant @a[team=!Spectator,x=5050,y=75,z=-5050,dx=-100,dy=-75,dz=100,tag=step3] only main:whoosh
tag @a[team=!Spectator,x=5050,y=80,z=-5050,dx=-100,dy=10,dz=100] remove fallingVoid

# Display Time remaining
execute if entity @e[tag=x,tag=!enableTeams] run function main:game/display_time_sidebar/solo
execute if entity @e[tag=x,tag=enableTeams] run function main:game/display_time_sidebar/teams

execute unless entity @e[tag=x,type=minecraft:armor_stand,tag=generating] if score itemSpawn itemsTimer matches 60 at @a run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 2
execute unless entity @e[tag=x,type=minecraft:armor_stand,tag=generating] if score itemSpawn itemsTimer matches 40 at @a run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 1.5
execute unless entity @e[tag=x,type=minecraft:armor_stand,tag=generating] if score itemSpawn itemsTimer matches 20 at @a run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 1
execute unless entity @e[tag=x,type=minecraft:armor_stand,tag=generating] if score itemSpawn itemsTimer matches 1 at @a run playsound minecraft:block.note_block.guitar master @a ~ ~ ~ 1 2

execute unless entity @e[tag=x,type=minecraft:armor_stand,tag=generating] if score itemSpawn itemsTimer matches 1 run tellraw @a ["",{"text":"\u25b6 "},{"text":"Spreading items...","color":"yellow"}]

# Give speed and resistance when score is 0

execute unless entity @e[tag=generating,tag=x,type=armor_stand] unless score event_id itemsTimer matches 9 at @a[scores={scoresSingle=..0}] run particle minecraft:flame ~ ~1 ~ 0 0.1 0 0.1 1 normal @a[scores={scoresSingle=1..}]
execute unless entity @e[tag=generating,tag=x,type=armor_stand] run effect give @a[scores={scoresSingle=..0}] minecraft:speed 1 2 true
execute unless entity @e[tag=generating,tag=x,type=armor_stand] run effect give @a[scores={scoresSingle=..0}] minecraft:resistance 1 2 true

# Random events

execute if entity @s[scores={sGameEvents=1},tag=!endStop] run function main:random_events/loop
execute if score EventDuration itemsTimer matches 0.. run function main:random_events/event_duration_is_secondes

#  Item Count

execute store result score items itemsTimer if entity @e[type=item,tag=itemToPickUp]

# Launch of the spawn procedure when the time is up and restart of the loop

execute if entity @s[tag=!endStop] if score itemSpawn itemsTimer matches 0 run function main:items/spawn_patch
execute if entity @s[tag=!endStop] if score itemSpawn itemsTimer matches ..-1 run scoreboard players operation itemSpawn itemsTimer = @e[tag=x,limit=1] sDropRate

# Loop

execute if entity @s[tag=!endStop] if score itemSpawn itemsTimer matches 1.. run scoreboard players remove itemSpawn itemsTimer 1

# Items detector

execute as @a[nbt={Inventory:[{tag:{ItemToPickUp:1}}]}] run function main:game/update_points

# Spectator 

gamemode spectator @a[team=Spectator,tag=!developer]
team join Spectator @a[team=Lobby,tag=!developer]

# As kill and tp

execute as @e[type=armor_stand,tag=asPoint] run scoreboard players add @s asLife 1
execute as @e[type=armor_stand,tag=asPoint] at @s run tp @s ~ ~0.1 ~
execute as @e[type=armor_stand,tag=asPoint] run kill @s[scores={asLife=40..}]

# Disable PVP System

execute unless score event_id itemsTimer matches 10 if entity @e[tag=!enablePvp,tag=x,type=armor_stand] run effect clear @a minecraft:weakness
execute unless score event_id itemsTimer matches 10 if entity @e[tag=!enablePvp,tag=x,type=armor_stand] run effect give @a[team=!Spectator] minecraft:weakness 1 255 true

# Weapon Give

execute if entity @s[tag=enablePvp] as @e[type=item] if data entity @s Item.tag.Weapon run kill @s
execute if entity @s[tag=enablePvp] as @a unless data entity @s Inventory[{Slot:0b}].tag.Weapon run clear @s #main:weapon

execute if entity @s[tag=enablePvp,scores={sPvpMode=1}] as @a[team=!Spectator,tag=step1,tag=!step2] run replaceitem entity @s hotbar.0 wooden_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:1024,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=1}] as @a[team=!Spectator,tag=step2,tag=!step3] run replaceitem entity @s hotbar.0 stone_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:1024,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=1}] as @a[team=!Spectator,tag=step3,tag=!step4] run replaceitem entity @s hotbar.0 iron_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:1024,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=1}] as @a[team=!Spectator,tag=step4,tag=!step5] run replaceitem entity @s hotbar.0 golden_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:1024,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=1}] as @a[team=!Spectator,tag=step5] run replaceitem entity @s hotbar.0 diamond_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:1024,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}

execute if entity @s[tag=enablePvp,scores={sPvpMode=2}] as @a[team=!Spectator,tag=step1,tag=!step2] run replaceitem entity @s hotbar.0 wooden_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:-2.4,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=2}] as @a[team=!Spectator,tag=step2,tag=!step3] run replaceitem entity @s hotbar.0 stone_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:-2.4,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=2}] as @a[team=!Spectator,tag=step3,tag=!step4] run replaceitem entity @s hotbar.0 iron_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:-2.4,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=2}] as @a[team=!Spectator,tag=step4,tag=!step5] run replaceitem entity @s hotbar.0 golden_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:-2.4,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}
execute if entity @s[tag=enablePvp,scores={sPvpMode=2}] as @a[team=!Spectator,tag=step5] run replaceitem entity @s hotbar.0 diamond_sword{Weapon:1,display:{Name:'{"text":"➔ Your sword","color":"white","bold":true,"italic":false}',Lore:['[{"text":"» ","color":"white","italic":false},{"text":"You can\'t drop this item","color":"red","italic":false}]','[{"text":"➣ ","color":"dark_gray","italic":false},{"text":"Damage: 3 ❤","color":"gray","italic":false}]']},HideFlags:63,Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:-2.4,Operation:0,UUIDLeast:765423,UUIDMost:249752,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Slot:"mainhand",Amount:5,Operation:0,UUIDMost:28692,UUIDLeast:179268}]}


# Stats Actionbar displaying

execute if entity @e[tag=x,tag=!enableTeams,type=armor_stand,tag=!generating] as @a[team=!Spectator] at @s unless block ~ ~ ~ water run function main:game/player_stats/solo/run
execute if entity @e[tag=x,tag=enableTeams,type=armor_stand,tag=!generating] as @a[team=!Spectator] at @s unless block ~ ~ ~ water run function main:game/player_stats/teams/run

# End Timer / End Game

execute if score *RemainderInTic timer matches 600 run title @a subtitle ""
execute if score *RemainderInTic timer matches 1..200 run title @a subtitle ""
execute if score *RemainderInTic timer matches 600 run execute at @a run playsound minecraft:entity.ender_dragon.growl block @a ~ ~ ~ 1 2
execute if score *RemainderInTic timer matches 600 run execute at @a run title @a times 20 80 40
execute if score *RemainderInTic timer matches 600 run execute at @a run title @a title {"text":"30 seconds left!","color":"red"}
execute if score *RemainderInTic timer matches 600 run bossbar set minecraft:match.timer color red
execute if score *RemainderInTic timer matches 200 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 200 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 200 run title @a title "10"
execute if score *RemainderInTic timer matches 180 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 180 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 180 run title @a title "9"
execute if score *RemainderInTic timer matches 160 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 160 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 160 run title @a title "8"
execute if score *RemainderInTic timer matches 140 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 140 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 140 run title @a title "7"
execute if score *RemainderInTic timer matches 120 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 120 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 120 run title @a title "6"
execute if score *RemainderInTic timer matches 100 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 100 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 100 run title @a title "5"
execute if score *RemainderInTic timer matches 80 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 80 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 80 run title @a title "4"
execute if score *RemainderInTic timer matches 60 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 60 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 60 run title @a title "3"
execute if score *RemainderInTic timer matches 40 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 40 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 40 run title @a title "2"
execute if score *RemainderInTic timer matches 20 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 20 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1
execute if score *RemainderInTic timer matches 20 run title @a title "1"
execute if score *RemainderInTic timer matches 1 run execute at @a run playsound minecraft:block.note_block.pling block @a ~ ~ ~ 1 1
execute if score *RemainderInTic timer matches 1 run execute at @a run playsound minecraft:block.note_block.basedrum block @a ~ ~ ~ 1 0.1

# Normal
    # End Timer
execute if entity @s[scores={sGameType=2},tag=!generating] if score *RemainderInTic timer matches ..1 run tag @s add endStop
    # End Score
execute if entity @s[scores={sGameType=1},tag=!enableTeams,tag=!generating] as @a[team=!Spectator] if score @s scoresSingle >= @e[tag=x,limit=1] scoreToReach run tag @e[tag=x] add endStop
execute if entity @s[scores={sGameType=1,sTeams=1},tag=enableTeams,tag=!generating] if score Red: scoresTeams < @s scoreToReach if score Blue: scoresTeams < @s scoreToReach run tag @s add notFinish
execute if entity @s[scores={sGameType=1,sTeams=2},tag=enableTeams,tag=!generating] if score Red: scoresTeams < @s scoreToReach if score Blue: scoresTeams < @s scoreToReach if score Green: scoresTeams < @s scoreToReach run tag @s add notFinish
execute if entity @s[scores={sGameType=1,sTeams=3},tag=enableTeams,tag=!generating] if score Red: scoresTeams < @s scoreToReach if score Blue: scoresTeams < @s scoreToReach if score Green: scoresTeams < @s scoreToReach if score Yellow: scoresTeams < @s scoreToReach run tag @s add notFinish
execute if entity @s[scores={sGameType=1},tag=enableTeams,tag=!generating] if entity @s[tag=!notFinish] run tag @s add endStop
execute if entity @s[scores={sGameType=1},tag=enableTeams,tag=!generating] run tag @s remove notFinish

execute as @e[tag=x,type=armor_stand] run function main:game/game_cancelled

execute if entity @s[tag=endStop,tag=!endForceStop] run function main:game/finish_game
